Index: binaries/data/mods/public/maps/random/rmgen/wall_builder.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/wall_builder.js
+++ binaries/data/mods/public/maps/random/rmgen/wall_builder.js
@@ -86,233 +78,262 @@ function WallElement(type, entity, angle, width, indent, bending)
 //	It's mainly the abstract shape defined in a Fortress instances wall because different styles can be used for it (see wallStyles)
 //
 //	type                  Descriptive string, example: "tiny". Not really needed (WallTool.wallTypes["type string"] is used). Mainly for custom wall elements
-//	wall                  Optional. Array of wall element strings. Can be set afterwards. Default is an epty array.
+//	wall                  Optional. Array of wall element strings. Can be set afterwards. Default is an empty array.
 //		Example: ["entrance", "wall", "cornerIn", "wall", "gate", "wall", "entrance", "wall", "cornerIn", "wall", "gate", "wall", "cornerIn", "wall"]
 //	centerToFirstElement  Optional. Object with properties "x" and "y" representing a vector from the visual center to the first wall element. Default is undefined
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 function Fortress(type, wall, centerToFirstElement)
 {
-	this.type = type; // Only usefull to get the type of the actual fortress
-	this.wall = (wall !== undefined) ? wall : [];
-	this.centerToFirstElement = undefined;
-}
-
-
-////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-//  wallStyles data structure for default wall styles
-//
-//	A wall style is an associative array with all wall elements of that style in it associated with the wall element type string
-//	wallStyles holds all the wall styles within an associative array with the civ string or another descriptive strings as key
-//	Examples: "athen", "rome_siege", "palisades", "fence", "road"
-////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-var wallStyles = {};
-
-// Generic civ dependent wall style definition. "rome_siege" needs some tweek...
-var wallScaleByType = {"athen" : 1.5, "brit" : 1.5, "cart" : 1.8, "gaul" : 1.5, "iber" : 1.5, "mace" : 1.5, "maur": 1.5, "pers" : 1.5, "ptol" : 1.5, "rome" : 1.5, "sele" : 1.5, "spart" : 1.5, "rome_siege" : 1.5};
-for (var style in wallScaleByType)
-{
-	var civ = style;
-	if (style == "rome_siege")
-		civ = "rome";
-	wallStyles[style] = {};
-	// Default wall elements
-	wallStyles[style]["tower"] = new WallElement("tower", "structures/" + style + "_wall_tower", PI, wallScaleByType[style]);
-	wallStyles[style]["endLeft"] = new WallElement("endLeft", "structures/" + style + "_wall_tower", PI, wallScaleByType[style]); // Same as tower. To be compatible with palisades...
-	wallStyles[style]["endRight"] = new WallElement("endRight", "structures/" + style + "_wall_tower", PI, wallScaleByType[style]); // Same as tower. To be compatible with palisades...
-	wallStyles[style]["cornerIn"] = new WallElement("cornerIn", "structures/" + style + "_wall_tower", 5*PI/4, 0, 0.35*wallScaleByType[style], PI/2); // 2^0.5 / 4 ~= 0.35 ~= 1/3
-	wallStyles[style]["cornerOut"] = new WallElement("cornerOut", "structures/" + style + "_wall_tower", 3*PI/4, 0.71*wallScaleByType[style], 0, -PI/2); // // 2^0.5 / 2 ~= 0.71 ~= 2/3
-	wallStyles[style]["wallShort"] = new WallElement("wallShort", "structures/" + style + "_wall_short", 0*PI, 2*wallScaleByType[style]);
-	wallStyles[style]["wall"] = new WallElement("wall", "structures/" + style + "_wall_medium", 0*PI, 4*wallScaleByType[style]);
-	wallStyles[style]["wallMedium"] = new WallElement("wall", "structures/" + style + "_wall_medium", 0*PI, 4*wallScaleByType[style]);
-	wallStyles[style]["wallLong"] = new WallElement("wallLong", "structures/" + style + "_wall_long", 0*PI, 6*wallScaleByType[style]);
-	// Gate and entrance wall elements
-	var gateWidth = 6*wallScaleByType[style];
-	wallStyles[style]["gate"] = new WallElement("gate", "structures/" + style + "_wall_gate", PI, gateWidth);
-	wallStyles[style]["entry"] = new WallElement("entry", undefined, 0*PI, gateWidth);
-	wallStyles[style]["entryTower"] = new WallElement("entryTower", "structures/" + civ + "_defense_tower", PI, gateWidth, -4*wallScaleByType[style]);
-	wallStyles[style]["entryFort"] = new WallElement("entryFort", "structures/" + civ + "_fortress", 0*PI, 8*wallScaleByType[style], 6*wallScaleByType[style]);
-	// Defensive wall elements with 0 width outside the wall
-	wallStyles[style]["outpost"] = new WallElement("outpost", "structures/" + civ + "_outpost", PI, 0, -4*wallScaleByType[style]);
-	wallStyles[style]["defenseTower"] = new WallElement("defenseTower", "structures/" + civ + "_defense_tower", PI, 0, -4*wallScaleByType[style]);
-	// Base buildings wall elements with 0 width inside the wall
-	wallStyles[style]["barracks"] = new WallElement("barracks", "structures/" + civ + "_barracks", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["civilCentre"] = new WallElement("civilCentre", "structures/" + civ + "_civil_centre", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["farmstead"] = new WallElement("farmstead", "structures/" + civ + "_farmstead", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["field"] = new WallElement("field", "structures/" + civ + "_field", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["fortress"] = new WallElement("fortress", "structures/" + civ + "_fortress", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["house"] = new WallElement("house", "structures/" + civ + "_house", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["market"] = new WallElement("market", "structures/" + civ + "_market", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["storehouse"] = new WallElement("storehouse", "structures/" + civ + "_storehouse", PI, 0, 4.5*wallScaleByType[style]);
-	wallStyles[style]["temple"] = new WallElement("temple", "structures/" + civ + "_temple", PI, 0, 4.5*wallScaleByType[style]);
-	// Generic space/gap wall elements
-	wallStyles[style]["space1"] = new WallElement("space1", undefined, 0*PI, wallScaleByType[style]);
-	wallStyles[style]["space2"] = new WallElement("space2", undefined, 0*PI, 2*wallScaleByType[style]);
-	wallStyles[style]["space3"] = new WallElement("space3", undefined, 0*PI, 3*wallScaleByType[style]);
-	wallStyles[style]["space4"] = new WallElement("space4", undefined, 0*PI, 4*wallScaleByType[style]);
+	this.type = type;
+	this.wall = wall || [];
+	this.centerToFirstElement = centerToFirstElement || undefined;
 }
-// Add wall fortresses for all generic styles
-wallStyles["athen"]["wallFort"] = new WallElement("wallFort", "structures/athen_fortress", 2*PI/2 /* PI/2 */, 5.1 /* 5.6 */, 1.9 /* 1.9 */);
-wallStyles["brit"]["wallFort"] = new WallElement("wallFort", "structures/brit_fortress", PI, 2.8);
-wallStyles["cart"]["wallFort"] = new WallElement("wallFort", "structures/cart_fortress", PI, 5.1, 1.6);
-wallStyles["gaul"]["wallFort"] = new WallElement("wallFort", "structures/gaul_fortress", PI, 4.2, 1.5);
-wallStyles["iber"]["wallFort"] = new WallElement("wallFort", "structures/iber_fortress", PI, 5, 0.2);
-wallStyles["mace"]["wallFort"] = new WallElement("wallFort", "structures/mace_fortress", 2*PI/2 /* PI/2 */, 5.1 /* 5.6 */, 1.9 /* 1.9 */);
-wallStyles["maur"]["wallFort"] = new WallElement("wallFort", "structures/maur_fortress", PI, 5.5);
-wallStyles["pers"]["wallFort"] = new WallElement("wallFort", "structures/pers_fortress", PI, 5.6/*5.5*/, 1.9/*1.7*/);
-wallStyles["ptol"]["wallFort"] = new WallElement("wallFort", "structures/ptol_fortress", 2*PI/2 /* PI/2 */, 5.1 /* 5.6 */, 1.9 /* 1.9 */);
-wallStyles["rome"]["wallFort"] = new WallElement("wallFort", "structures/rome_fortress", PI, 6.3, 2.1);
-wallStyles["sele"]["wallFort"] = new WallElement("wallFort", "structures/sele_fortress", 2*PI/2 /* PI/2 */, 5.1 /* 5.6 */, 1.9 /* 1.9 */);
-wallStyles["spart"]["wallFort"] = new WallElement("wallFort", "structures/spart_fortress", 2*PI/2 /* PI/2 */, 5.1 /* 5.6 */, 1.9 /* 1.9 */);
-// Adjust "rome_siege" style
-wallStyles["rome_siege"]["wallFort"] = new WallElement("wallFort", "structures/rome_army_camp", PI, 7.2, 2);
-wallStyles["rome_siege"]["entryFort"] = new WallElement("entryFort", "structures/rome_army_camp", PI, 12, 7);
-wallStyles["rome_siege"]["house"] = new WallElement("house", "structures/rome_tent", PI, 0, 4);
-
-// Add special wall styles not well to implement generic (and to show how custom styles can be added)
-
-// Add wall style "palisades"
-wallScaleByType["palisades"] = 0.55;
-wallStyles["palisades"] = {};
-wallStyles["palisades"]["wall"] = new WallElement("wall", "other/palisades_rocks_medium", 0*PI, 2.3);
-wallStyles["palisades"]["wallMedium"] = new WallElement("wall", "other/palisades_rocks_medium", 0*PI, 2.3);
-wallStyles["palisades"]["wallLong"] = new WallElement("wall", "other/palisades_rocks_long", 0*PI, 3.5);
-wallStyles["palisades"]["wallShort"] = new WallElement("wall", "other/palisades_rocks_short", 0*PI, 1.2);
-wallStyles["palisades"]["tower"] = new WallElement("tower", "other/palisades_rocks_tower", -PI/2, 0.7);
-wallStyles["palisades"]["wallFort"] = new WallElement("wallFort", "other/palisades_rocks_fort", PI, 1.7);
-wallStyles["palisades"]["gate"] = new WallElement("gate", "other/palisades_rocks_gate", PI, 3.6);
-wallStyles["palisades"]["entry"] = new WallElement("entry", undefined, wallStyles["palisades"]["gate"].angle, wallStyles["palisades"]["gate"].width);
-wallStyles["palisades"]["entryTower"] = new WallElement("entryTower", "other/palisades_rocks_watchtower", 0*PI, wallStyles["palisades"]["gate"].width, -3);
-wallStyles["palisades"]["entryFort"] = new WallElement("entryFort", "other/palisades_rocks_fort", PI, 6, 3);
-wallStyles["palisades"]["cornerIn"] = new WallElement("cornerIn", "other/palisades_rocks_curve", 3*PI/4, 2.1, 0.7, PI/2);
-wallStyles["palisades"]["cornerOut"] = new WallElement("cornerOut", "other/palisades_rocks_curve", 5*PI/4, 2.1, -0.7, -PI/2);
-wallStyles["palisades"]["outpost"] = new WallElement("outpost", "other/palisades_rocks_outpost", PI, 0, -2);
-wallStyles["palisades"]["house"] = new WallElement("house", "other/celt_hut", PI, 0, 5);
-wallStyles["palisades"]["barracks"] = new WallElement("barracks", "structures/gaul_tavern", PI, 0, 5);
-wallStyles["palisades"]["endRight"] = new WallElement("endRight", "other/palisades_rocks_end", -PI/2, 0.2);
-wallStyles["palisades"]["endLeft"] = new WallElement("endLeft", "other/palisades_rocks_end", PI/2, 0.2);
-
-// Add special wall style "road"
-// NOTE: This is not a wall style in the common sense. Use with care!
-wallStyles["road"] = {};
-wallStyles["road"]["short"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_short.xml", PI/2, 4.5);
-wallStyles["road"]["long"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_long.xml", PI/2, 9.5);
-wallStyles["road"]["cornerLeft"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_corner.xml", -PI/2, 4.5-2*1.25, 1.25, PI/2); // Correct width by -2*indent to fit xStraicht/corner
-wallStyles["road"]["cornerRight"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_corner.xml", 0*PI, 4.5-2*1.25, -1.25, -PI/2); // Correct width by -2*indent to fit xStraicht/corner
-wallStyles["road"]["curveLeft"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_curve_small.xml", -PI/2, 4.5+2*0.2, -0.2, PI/2); // Correct width by -2*indent to fit xStraicht/corner
-wallStyles["road"]["curveRight"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_curve_small.xml", 0*PI, 4.5+2*0.2, 0.2, -PI/2); // Correct width by -2*indent to fit xStraicht/corner
-wallStyles["road"]["start"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_end.xml", PI/2, 2);
-wallStyles["road"]["end"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_end.xml", -PI/2, 2);
-wallStyles["road"]["xStraight"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_intersect_x.xml", 0*PI, 4.5);
-wallStyles["road"]["xLeft"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_intersect_x.xml", 0*PI, 4.5, 0, PI/2);
-wallStyles["road"]["xRight"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_intersect_x.xml", 0*PI, 4.5, 0, -PI/2);
-wallStyles["road"]["tLeft"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_intersect_T.xml", PI, 4.5, 1.25);
-wallStyles["road"]["tRight"] = new WallElement("road", "actor|props/special/eyecandy/road_temperate_intersect_T.xml", 0*PI, 4.5, -1.25);
-
-// Add special wall element collection "other"
-// NOTE: This is not a wall style in the common sense. Use with care!
-wallStyles["other"] = {};
-wallStyles["other"]["fence"] = new WallElement("fence", "other/fence_long", -PI/2, 3.1);
-wallStyles["other"]["fence_medium"] = new WallElement("fence", "other/fence_long", -PI/2, 3.1);
-wallStyles["other"]["fence_short"] = new WallElement("fence_short", "other/fence_short", -PI/2, 1.5);
-wallStyles["other"]["fence_stone"] = new WallElement("fence_stone", "other/fence_stone", -PI/2, 2.5);
-wallStyles["other"]["palisade"] = new WallElement("palisade", "other/palisades_rocks_short", 0, 1.2);
-wallStyles["other"]["column"] = new WallElement("column", "other/column_doric", 0, 1);
-wallStyles["other"]["obelisk"] = new WallElement("obelisk", "other/obelisk", 0, 2);
-wallStyles["other"]["spike"] = new WallElement("spike", "other/palisades_angle_spike", -PI/2, 1);
-wallStyles["other"]["bench"] = new WallElement("bench", "other/bench", PI/2, 1.5);
-wallStyles["other"]["benchForTable"] = new WallElement("benchForTable", "other/bench", 0, 0.5);
-wallStyles["other"]["table"] = new WallElement("table", "other/table_rectangle", 0, 1);
-wallStyles["other"]["table_square"] = new WallElement("table_square", "other/table_square", PI/2, 1);
-wallStyles["other"]["flag"] = new WallElement("flag", "special/rallypoint", PI, 1);
-wallStyles["other"]["standing_stone"] = new WallElement("standing_stone", "gaia/special_ruins_standing_stone", PI, 1);
-wallStyles["other"]["settlement"] = new WallElement("settlement", "gaia/special_settlement", PI, 6);
-wallStyles["other"]["gap"] = new WallElement("gap", undefined, 0, 2);
-wallStyles["other"]["gapSmall"] = new WallElement("gapSmall", undefined, 0, 1);
-wallStyles["other"]["gapLarge"] = new WallElement("gapLarge", undefined, 0, 4);
-wallStyles["other"]["cornerIn"] = new WallElement("cornerIn", undefined, 0, 0, 0, PI/2);
-wallStyles["other"]["cornerOut"] = new WallElement("cornerOut", undefined, 0, 0, 0, -PI/2);
-
 
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-//  fortressTypes data structure for some default fortress types
+//  g_FortressTypes data structure for some default fortress types (defined above)
 //
 //	A fortress type is just an instance of the Fortress class with actually something in it
 //	fortressTypes holds all the fortresses within an associative array with a descriptive string as key (e.g. matching the map size)
 //	Examples: "tiny", "veryLarge"
 ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-var fortressTypes = {};
-// Setup some default fortress types
-// Add fortress type "tiny"
-fortressTypes["tiny"] = new Fortress("tiny");
-var wallPart = ["gate", "tower", "wallShort", "cornerIn", "wallShort", "tower"];
-fortressTypes["tiny"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "small"
-fortressTypes["small"] = new Fortress("small");
-var wallPart = ["gate", "tower", "wall", "cornerIn", "wall", "tower"];
-fortressTypes["small"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "medium"
-fortressTypes["medium"] = new Fortress("medium");
-var wallPart = ["gate", "tower", "wallLong", "cornerIn", "wallLong", "tower"];
-fortressTypes["medium"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "normal"
-fortressTypes["normal"] = new Fortress("normal");
-var wallPart = ["gate", "tower", "wall", "cornerIn", "wall", "cornerOut", "wall", "cornerIn", "wall", "tower"];
-fortressTypes["normal"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "large"
-fortressTypes["large"] = new Fortress("large");
-var wallPart = ["gate", "tower", "wallLong", "cornerIn", "wallLong", "cornerOut", "wallLong", "cornerIn", "wallLong", "tower"];
-fortressTypes["large"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "veryLarge"
-fortressTypes["veryLarge"] = new Fortress("veryLarge");
-var wallPart = ["gate", "tower", "wall", "cornerIn", "wall", "cornerOut", "wallLong", "cornerIn", "wallLong", "cornerOut", "wall", "cornerIn", "wall", "tower"];
-fortressTypes["veryLarge"].wall = wallPart.concat(wallPart, wallPart, wallPart);
-// Add fortress type "giant"
-fortressTypes["giant"] = new Fortress("giant");
-var wallPart = ["gate", "tower", "wallLong", "cornerIn", "wallLong", "cornerOut", "wallLong", "cornerIn", "wallLong", "cornerOut", "wallLong", "cornerIn", "wallLong", "tower"];
-fortressTypes["giant"].wall = wallPart.concat(wallPart, wallPart, wallPart);
+
+// Set some default fortress types
+for (let key of g_FortressTypeKeys)
+	g_FortressTypes[key] = new Fortress(key);
+
+g_FortressTypes["tiny"].wall = ["gate", "tower", "short", "cornerIn", "short", "tower"];
+g_FortressTypes["small"].wall = ["gate", "tower", "medium", "cornerIn", "medium", "tower"];
+g_FortressTypes["medium"].wall = ["gate", "tower", "long", "cornerIn", "long", "tower"];
+g_FortressTypes["normal"].wall = ["gate", "tower", "medium", "cornerIn", "medium", "cornerOut", "medium", "cornerIn", "medium", "tower"];
+g_FortressTypes["large"].wall = ["gate", "tower", "long", "cornerIn", "long", "cornerOut", "long", "cornerIn", "long", "tower"];
+g_FortressTypes["veryLarge"].wall = ["gate", "tower", "medium", "cornerIn", "medium", "cornerOut", "long", "cornerIn", "long", "cornerOut", "medium", "cornerIn", "medium", "tower"];
+g_FortressTypes["giant"].wall = ["gate", "tower", "long", "cornerIn", "long", "cornerOut", "long", "cornerIn", "long", "cornerOut", "long", "cornerIn", "long", "tower"];
+
+for (let type in g_FortressTypes)
+{
+	let wallPart = g_FortressTypes[type].wall;
+	g_FortressTypes[type].wall = wallPart.concat(wallPart, wallPart, wallPart);
+}
 
 // Setup some better looking semi default fortresses for "palisades" style
-var fortressTypeKeys = ["tiny", "small", "medium", "normal", "large", "veryLarge", "giant"];
-for (var i = 0; i < fortressTypeKeys.length; i++)
+for (let fortType of g_FortressTypeKeys)
 {
-	var newKey = fortressTypeKeys[i] + "Palisades";
-	var oldWall = fortressTypes[fortressTypeKeys[i]].wall;
-	fortressTypes[newKey] = new Fortress(newKey);
+	var newKey = fortType + "Palisades";
+	var oldWall = g_FortressTypes[fortType].wall;
+	g_FortressTypes[newKey] = new Fortress(newKey);
 	var fillTowersBetween = ["wallShort", "wall", "wallLong", "endLeft", "endRight", "cornerIn", "cornerOut"];
-	for (var j = 0; j < oldWall.length; j++)
+	for (var j = 0; j < oldWall.length; ++j)
 	{
-		fortressTypes[newKey].wall.push(oldWall[j]); // Only works if the first element is not in fillTowersBetween (e.g. entry or gate like it should be)
+		g_FortressTypes[newKey].wall.push(oldWall[j]); // Only works if the first element is not in fillTowersBetween (e.g. entry or gate like it should be)
 		if (j+1 < oldWall.length)
 			if (fillTowersBetween.indexOf(oldWall[j]) > -1 && fillTowersBetween.indexOf(oldWall[j+1]) > -1) // ... > -1 means "exists" here
-				fortressTypes[newKey].wall.push("tower");
+				g_FortressTypes[newKey].wall.push("tower");
 	}
 }
 
 // Setup some balanced (to civ type fortresses) semi default fortresses for "palisades" style
 // TODO
 
-// Add some "fortress types" for roads (will only work with style "road")
-// ["start", "short", "xRight", "xLeft", "cornerLeft", "xStraight", "long", "xLeft", "xRight", "cornerRight", "tRight", "tLeft", "xRight", "xLeft", "curveLeft", "xStraight", "curveRight", "end"];
-var wall = ["short", "curveLeft", "short", "curveLeft", "short", "curveLeft", "short", "curveLeft"];
-fortressTypes["road01"] = new Fortress("road01", wall);
-var wall = ["short", "cornerLeft", "short", "cornerLeft", "short", "cornerLeft", "short", "cornerLeft"];
-fortressTypes["road02"] = new Fortress("road02", wall);
-var wall = ["xStraight", "curveLeft", "xStraight", "curveLeft", "xStraight", "curveLeft", "xStraight", "curveLeft"];
-fortressTypes["road03"] = new Fortress("road03", wall);
-var wall = ["start", "curveLeft", "tRight", "cornerLeft", "tRight", "curveRight", "short", "xRight", "curveLeft", "xRight", "short", "cornerLeft", "tRight", "short",
-	"curveLeft", "short", "tRight", "cornerLeft", "short", "xRight", "curveLeft", "xRight", "short", "curveRight", "tRight", "cornerLeft", "tRight", "curveLeft", "end"];
-fortressTypes["road04"] = new Fortress("road04", wall);
-var wall = ["start", "tLeft", "short", "xRight",
-	"curveLeft", "xRight", "tRight", "cornerLeft", "tRight",
-	"curveLeft", "short", "tRight", "cornerLeft", "xRight",
-	"cornerLeft", "xRight", "short", "tRight", "curveLeft", "end"];
-fortressTypes["road05"] = new Fortress("road05", wall);
-
 
 ///////////////////////////////
 // Define some helper functions
 ///////////////////////////////
 
+/**
+ * Get a wall element of a style.
+ * 
+ * Valid elements:
+ *   long, medium, short, start, end, cornerIn, cornerOut, tower, fort, gate
+ * 
+ * Kept for backwards compatibility:
+ *   wallLong, wallMedium, wall, wallShort, endLeft, endRight, entry, entryTower, entryFort
+ * 
+ * If an element of the form `gap{x}` is requested, where `{x}` is a number,
+ * then a non-blocking gap of `x` length is returned.
+ * 
+ * If an element of the form `turn{x}` is requested where `{x}` is either
+ * `out` or `in` (case in-sensitive), then a 90 degree (PI/2 radians) bend
+ * with zero length is returned in the specified direction.
+ * 
+ * You can specify a normal structure (ie. `house`, `apadana` `barracks`)
+ * and the function will attempt to return the appropriate civ's building
+ * of that type with appropriate indentation away from the wall.
+ * @todo do something about the arbitrary-ness of the indent.
+ * 
+ * If after all that, the function still can't work out what's requested,
+ * it returns a wall tower.
+ * 
+ * @param style The style from which this element should come from
+ * @param element The element to fetch
+ * @return The wall element requested. Or a tower element.
+ */
+function getWallElement(style="athen_stone", element)
+{
+	if (g_WallStyleList.indexOf(style) < 0)
+	{
+		warn("getWallElement: Style '"+style+"' not recognised. (Falling back to '" + FALLBACK_CIV + "_stone'.)");
+		style = FALLBACK_CIV + "_stone";
+	}
+	if (g_WallStyles[style][element])
+		return g_WallStyles[style][element];
+
+	// Attempt to derive any unknown elements.
+	// Defaults to a wall tower piece
+	var wallset = g_WallStyles[style];
+	var civ = style.split("_")[0];
+	var ret = clone(wallset.tower);
+
+	// We use clone() so we don't change the attributes of the object we're referencing
+	switch (element)
+	{
+
+	case "cornerIn":
+		if (wallset.quarterCurve)
+			ret = clone(wallset.quarterCurve);
+		else
+		{
+			ret.angle += PI/4
+			ret.indent = ret.length * 0.25;
+			ret.length = 0;
+		}
+		ret.bend = PI/2;
+		break;
+
+	case "cornerOut":
+		if (wallset.quarterCurve)
+		{
+			ret = clone(wallset.quarterCurve);
+			ret.angle += PI/2;
+			ret.indent -= ret.indent*2;
+		}
+		else
+		{
+			ret.angle -= PI/4;
+			ret.length *= 0.71;
+		}
+		ret.bend = -PI/2;
+		break;
+
+	case "wallShort":
+		warn("getWallElement: Deprecated use of 'wallShort' (please use 'short')");
+		ret = clone(wallset.short);
+		break;
+
+	case "wallMedium":
+	case "wall":
+		warn("getWallElement: Deprecated use of '"+element+"' (please use 'medium')");
+		ret = clone(wallset.medium);
+		break;
+
+	case "wallLong":
+		warn("getWallElement: Deprecated use of 'wallLong' (please use 'long')");
+		ret = clone(wallset.long);
+		break;
+
+	case "entry":
+		ret.entPath = undefined;
+		ret.length = clone(g_WallStyles[style].gate.length);
+		break;
+
+	case "entryTower":
+		ret.entPath = (g_CivList.indexOf(civ) > -1) ? "structures/"+civ+"_defense_tower" : "other/palisades_rocks_watchtower";
+		ret.indent = ret.length * -3;
+		ret.length = clone(g_WallStyles[style].gate.length);
+		break;
+
+	case "entryFort":
+		ret = clone(g_WallStyles[style].fort);
+		ret.angle -= PI;
+		ret.length *= 1.5;
+		ret.indent = ret.length;
+		break;
+
+	case "endLeft":
+		warn("getWallElement: Deprecated use of 'endLeft' (please use 'start')");
+	case "start":
+		if (wallset.end)
+		{
+			ret = clone(wallset.end);
+			ret.angle += PI;
+		}
+		break;
+
+	case "endRight":
+		warn("getWallElement: Deprecated use of 'endRight' (please use 'end')");
+	case "end":
+		if (wallset.end)
+			ret = clone(wallset.end);
+		break;
+
+	default:
+		if (g_CivList.indexOf(civ) == -1)
+			civ = FALLBACK_CIV;
+		// Is it a structure?
+		var entPath = "structures/"+civ+"_"+element;
+		if (RMS.TemplateExists(entPath))
+		{
+			if (["outpost", "defense_tower"].indexOf(element) > -1)
+				ret.indent = ret.length * -3;
+			else
+				ret.indent = ret.length * 3.5;
+			ret.entPath = entPath;
+			ret.length = 0;
+		}
+		else if (element.slice(0, 3) === "gap") // A gap?
+		{
+			ret.entPath = undefined;
+			ret.angle = 0;
+			ret.length = +element.slice(3);
+		}
+		else if (element.slice(0, 4) === "turn") // A bend?
+		{
+			let dir = element.slice(4).toLowerCase();
+			if (dir === "out" || dir === "in")
+			{
+				ret.entPath = undefined;
+				ret.angle = PI/2;
+				ret.length = 0;
+				if (dir === "out")
+					ret.angle -= ret.angle;
+			}
+			else
+				warn("Unrecognised turn direction given: '"+dir+"' ("+ style+").");
+		}
+		else // Or... I give up.
+			warn("Unrecognised wall element: '"+element+"' ("+ style+"). Defaulting to 'tower'.");
+	}
+
+	// Cache to save having to calculate this element again
+	g_WallStyles[style][element] = ret;
+
+	return ret;
+}
+
+/**
+ * Set a wall element of a style.
+ * 
+ * @param style The style to which this element belongs
+ * @param element The element to add
+ * @param path The template path to read values from
+ */
+function setWallElement(style, element, path)
+{
+	var template = RMS.GetTemplate(path);
+	template = GetTemplateDataHelper(template);
+
+	if (!g_WallStyles[style])
+		g_WallStyles[style] = {};
+
+	var length = (template.wallPiece) ? template.wallPiece.length : template.obstruction.shape.width;
+	g_WallStyles[style][element] = {
+		"entPath": path,
+		"angle": (template.wallPiece) ? template.wallPiece.angle : PI,
+		"length": length / CELL_SIZE,
+		"indent": (template.wallPiece) ? template.wallPiece.indent / CELL_SIZE : 0,
+		"bend": (template.wallPiece) ? template.wallPiece.bend : 0
+	};
+}
+
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //  getWallAlignment
 //
@@ -320,50 +341,52 @@ fortressTypes["road05"] = new Fortress("road05", wall);
 //	Placing the first wall element at startX/startY placed with an angle given by orientation
 //	An alignment can be used to get the "center" of a "wall" (more likely used for fortresses) with getCenterToFirstElement
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-function getWallAlignment(startX, startY, wall, style, orientation)
+function getWallAlignment(startX, startY, wall=[], style="athen_stone", orientation=0)
 {
-	// Graciously handle arguments
-	if (wall === undefined)
-		wall = [];
-	if (!wallStyles.hasOwnProperty(style))
-	{
-		warn("Function getWallAlignment: Unknown style: " + style + ' (falling back to "athen")');
-		style = "athen";
-	}
-	orientation = (orientation || 0);
-	
 	var alignment = [];
 	var wallX = startX;
 	var wallY = startY;
-	for (var i = 0; i < wall.length; i++)
+
+	for (var i = 0; i < wall.length; ++i)
 	{
-		var element = wallStyles[style][wall[i]];
+		var element = getWallElement(style, wall[i]);
 		if (element === undefined && i == 0)
-			warn("No valid wall element: " + wall[i]);
+		{
+			warn("Not a valid wall element: style = " + style + ", wall[" +i+ "] = " +wall[i]+ "; .entPath = " +element.entPath+ ", .length = " +element.length+ ", .angle = " +element.angle+ ", .indent = " +element.indent+ ", .bend = " +element.bend);
+			continue;
+		}
+
 		// Indentation
 		var placeX = wallX - element.indent * cos(orientation);
 		var placeY = wallY - element.indent * sin(orientation);
+
 		// Add wall elements entity placement arguments to the alignment
-		alignment.push({"x": placeX, "y": placeY, "entity": element.entity, "angle":orientation + element.angle});
+		alignment.push({"x": placeX, "y": placeY, "entPath": element.entPath, "angle":orientation + element.angle});
+
 		// Preset vars for the next wall element
 		if (i+1 < wall.length)
 		{
-			orientation += element.bending;
-			var nextElement = wallStyles[style][wall[i+1]];
+			orientation += element.bend;
+			var nextElement = getWallElement(style, wall[i+1]);
 			if (nextElement === undefined)
-				warn("No valid wall element: " + wall[i+1]);
-			var distance = (element.width + nextElement.width)/2;
+			{
+				warn("Not a valid wall element: style = " + style + ", wall[" +(i+1)+ "] = " +wall[i+1]+ "; .entPath = " +nextElement.entPath+ ", .length = " +nextElement.length+ ", .angle = " +nextElement.angle+ ", .indent = " +nextElement.indent+ ", .bend = " +nextElement.bend);
+				continue;
+			}
+			
+			var distance = (element.length + nextElement.length)/2 - getOverlap(style);
 			// Corrections for elements with indent AND bending
 			var indent = element.indent;
-			var bending = element.bending;
-			if (bending !== 0 && indent !== 0)
+			var bend = element.bend;
+			if (bend !== 0 && indent !== 0)
 			{
 				// Indent correction to adjust distance
-				distance += indent*sin(bending);
+				distance += indent*sin(bend);
 				// Indent correction to normalize indentation
 				wallX += indent * cos(orientation);
 				wallY += indent * sin(orientation);
 			}
+			
 			// Set the next coordinates of the next element in the wall without indentation adjustment
 			wallX -= distance * sin(orientation);
 			wallY += distance * cos(orientation);
@@ -383,7 +406,7 @@ function getWallAlignment(startX, startY, wall, style, orientation)
 function getCenterToFirstElement(alignment)
 {
 	var centerToFirstElement = {"x": 0, "y": 0};
-	for (var i = 0; i < alignment.length; i++)
+	for (var i = 0; i < alignment.length; ++i)
 	{
 		centerToFirstElement.x -= alignment[i].x/alignment.length;
 		centerToFirstElement.y -= alignment[i].y/alignment.length;
